#include <QtGui>
#include <iostream>
#include "bscannyview.h"
#include "math.h"

using namespace std;


BSCannyView::BSCannyView (QImage *im, BSDetector *sd)
{
  int w = im->width ();
  int h = im->height ();
  image = im;
  setScene (new QGraphicsScene (0, 0, w, h));
  canny = new BSCannyItem (w, h, image, sd);
  //setBackgroundBrush (QBrush (*image));
  scene()->addItem (canny);
  setWindowTitle ("CannyLine comparator");
}


BSCannyView::~BSCannyView ()
{
  scene()->removeItem (canny);
  delete canny;
}


void BSCannyView::paint (QPainter *painter,
                         const QStyleOptionGraphicsItem *option,
                         QWidget *widget)
{
  Q_UNUSED (painter);
  Q_UNUSED (option);
  Q_UNUSED (widget);
}


bool BSCannyView::processKeyEvent (QKeyEvent *event)
{
  bool processed = false;
  switch (event->key ())
  {
    case Qt::Key_I : // Info
      canny->toggleType ();
      scene()->update ();
      update ();
      break;
  }
  return processed;
}
