#include <QtGui>
#include <iostream>
#include "bsyorkview.h"
#include "math.h"

using namespace std;


BSYorkView::BSYorkView (QImage *im, BSDetector *sd)
{
  int w = im->width ();
  int h = im->height ();
  image = im;
  setScene (new QGraphicsScene (0, 0, w, h));
  york = new BSYorkItem (w, h, image, sd);
  //setBackgroundBrush (QBrush (*image));
  scene()->addItem (york);
  setWindowTitle (york->itemTitle ());
}


BSYorkView::~BSYorkView ()
{
  scene()->removeItem (york);
  delete york;
}


void BSYorkView::paint (QPainter *painter,
                         const QStyleOptionGraphicsItem *option,
                         QWidget *widget)
{
  Q_UNUSED (painter);
  Q_UNUSED (option);
  Q_UNUSED (widget);
}


bool BSYorkView::processKeyEvent (QKeyEvent *event)
{
  bool processed = false;
  switch (event->key ())
  {
    case Qt::Key_I : // Info
      york->toggleType (event->modifiers () & Qt::ShiftModifier);
      scene()->update ();
      update ();
      setWindowTitle (york->itemTitle ());
      break;
    case Qt::Key_D : // Canny dilation
      if (york->toggleCannyDilation ())
      {
        scene()->update ();
        update ();
      }
      break;
    case Qt::Key_J : // Info
      york->computeBScovering ();
      break;
  }
  return processed;
}
